<?php

/**
 * Class UnknownFunctionalContentSettingException
 *
 * Exception to throw when a functional content setting is requested that is not
 * known. Likely indicates that an implementation of hook_functional_content()
 * is missing.
 */
class UnknownFunctionalContentSettingException extends RuntimeException {

  /**
   * UnknownFunctionalContentItemException constructor.
   *
   * @param string $setting
   *   Setting name that is unknown.
   */
  public function __construct($setting) {
    $message = t('Unknown Functional Content item: @item', array(
      '@item' => $setting,
    ));
    parent::__construct($message);
  }
}
